// helpers for dealing with fillter, experiment and visibilitybuffer options/optionmaps
//   Author:  Harro Verkouter, 9-Jul-2018
//
//   $Id: option_map.h,v 1.1.2.1 2018/08/21 12:26:29 verkout Exp $
//
#ifndef OPTION_MAP_H
#define OPTION_MAP_H


#include <casacore/casa/BasicSL/String.h>
#include <map>
#include <string>

typedef std::map<casacore::String, casacore::String> optionmap_type;
typedef casacore::String(*xform_function)(casacore::String);

casacore::String identity_xform(casacore::String x);
casacore::String lower_case(casacore::String x);
casacore::String upper_case(casacore::String x);
casacore::String capitalize(casacore::String x);

// Allow for specification of a key- and/or value transform function to e.g.
// have lower-case keys always
optionmap_type mk_optionmap(std::string const& opts, char sep=';', xform_function key_xform=identity_xform, xform_function value_xform=identity_xform);

#endif
