#ifndef FITS_IDI_H
#define FITS_IDI_H

#include <casacore/casa/aips.h>
#include <casacore/fits/FITS/fits.h>
#include <jive/ms2uvfitsimpl/FITSUtils/FITSBinaryTableHDU.h>

// Add common FITS-IDI keywords.
//
extern void addCommonKeywords(FITSBinaryTableHDU *tab, casacore::Int tabrev,
			      casacore::String& obscode, casacore::Int no_stkd,
			      casacore::Int stk_1, casacore::Int no_band,
			      casacore::Int no_chan, casacore::Float ref_freq,
			      casacore::Float chan_bw, casacore::Float ref_pixl);

// Add an extra FITS-IDI keyword.
//
extern void addExtraKeyword(FITSBinaryTableHDU *tab, const char *n,
			    casacore::Int v);

#endif
