//
//  Struct, describing the adress of an interferometer
//
//
#ifndef INTERFEROMETERDESCR_H
#define INTERFEROMETERDESCR_H


#ifndef HVTYPES_H
#include <vlbi/DtdLUT/hvtypes.h>
#endif

//
//  Forward declare
//
class ostream;

//
//  Basically all we want to know from the interferometerdescr is its
//  total index!
//
struct InterferometerDescr
{
    InterferometerDescr( uint32 index=0 ) : totalindex( index )
    {
    }

    inline operator int32() const
    {
        return (int32)totalindex;
    }
    inline operator uint32() const
    {
        return totalindex;
    }

    inline InterferometerDescr& operator=( const uint32 val )
    {
        totalindex=val;
        return *this;
    }

    inline uint32  getZeroBasedIFnr( void ) const
    {
	return totalindex;
    }
    

private:
    //
    //  That's it...
    //
    uint32   totalindex;
};

ostream& operator<<( ostream& os, const InterferometerDescr& ifref );


#endif
