//
//  Range -> class that transforms a string into an array of inetegers; usr. is 
//           able to specifiy range(s) or single numbers
//
//
//  Author:   Harro Verkouter  19-10-1998
//
//
//   $Id: Range.h,v 1.1.1.1 2000/03/20 15:15:40 verkout Exp $
//
#ifndef RANGE_H
#define RANGE_H


//
//  We need the string-class
//
#ifndef AIPS_STRING_H
#include <aips/Utilities/String.h>
#endif

#ifndef CONTAINER_H
#include <vlbi/tmplsrc/Container.h>
#endif

//
// The class itself...
//
class Range
{
public:

    //
    // Forward declare:
    //
    class Iterator;
    
    friend class Iterator;

    //
    //  The Range::iterator...
    //
    class Iterator
    {
	friend class Range;
    public:
	//
	//  unbound
	//
	Iterator();

	//
	//  Copy
	//
	Iterator( const Range::Iterator& other );

	//
	//  Assignment
	//
	Range::Iterator& operator=( const Range::Iterator& rval );
	
	//
	// reset to zero
	//
	void   reset( void );
	void   next( void );
	
	//
	// returns true if at end.
	//
	Bool   pastEnd( void ) const;

	Int&        operator*();
	const Int&  operator*() const;
	const Int*  operator->() const;

	//
	//  Delete 
	//
	~Iterator();

    private:
	//
	//  Only ranges can create valid iterators!
	//
	Iterator( uInt val, Range* parent );
	
	//
	//  The index into the Range's vector of values
	//
	uInt         itsIndex;

	//
	//  Pointer to parent rang. If null, the iterator is invalid
	//
	Range*       itsParent;
    };



    //
    //  A zero-range
    //
    Range();
    
    //
    //  Range from string
    //
    Range( const String& str );

    //
    // Return Iterators
    //
    Range::Iterator  first( void ) const;
    Range::Iterator  last( void ) const;

    //
    //  Delete the range
    //
    ~Range();
    
private:
    //
    //  The range's private parts...
    //
    Container<Int>    itsValues;

    //
    //  For now, disable copying/assignment
    //
    Range( const Range& );
    Range& operator=( const Range& );
};



#endif
