//
//  AntennaDB -> Abstract base-class for classes that whish to act as
//  a AntennaDatabase server.
//
//  Must be able to deliver the requested info.
//
//
//  Author:   Harro Verkouter, 1-12-1998
//
//
//   $Id: AntennaDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef ANTENNADB_H
#define ANTENNADB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef ANTENNAINFO_H
#include <vlbi/j2ms/AntennaInfo.h>
#endif


//
//  Forward declarations
//
class String;


class AntennaDB
{
public:
    //
    //  Create a database object...
    //
    AntennaDB();

    //
    //  Do a lookup based on code
    //
    virtual AntennaInfo operator[]( const String& key ) const = 0;
    virtual Bool        searchAntenna( AntennaInfo& airef, const String& key ) const = 0;
    
    //
    //  Delete the resources this database used....
    //
    virtual ~AntennaDB();

private:
    //
    //  Let's prohibit these, it's not wise to copy databases, assign
    //  to them
    //
    AntennaDB( const AntennaDB& );
    AntennaDB& operator=( const AntennaDB& );
};



#endif
