//
//  FrequencyDB
//
//  A database interface to locate frequency setups
//
//  Author:   Harro Verkouter,   3-12-1998
//
//  $Id: FrequencyDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef FREQUENCYDB_H
#define FREQUENCYDB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef FREQUENCYCONFIG_H
#include <vlbi/j2ms/FrequencyConfig.h>
#endif

//
//  Forward declarations
//
class String;


class FrequencyDB
{
public:
    //
    //  Create a database object...
    //
    FrequencyDB();

    //
    //  Do a lookup based on code
    //
    virtual FrequencyConfig operator[]( const String& key ) const = 0;
    virtual Bool            searchFrequencyConfig( FrequencyConfig& fcref, const String& key ) const = 0;
    
    //
    //  Delete the resources this database used....
    //
    virtual ~FrequencyDB();

private:
    //
    //  Let's prohibit these, it's not wise to copy databases, assign
    //  to them
    //
    FrequencyDB( const FrequencyDB& );
    FrequencyDB& operator=( const FrequencyDB& );
};

#endif
