//
//   History - keep track of which frequency setups with which
//   correlator setups are written into which measurementSet
//
//  The idea was to have this struct only defined within a function
//  but then the template instantiation cannot do it's work because
//  they don't know the struct definition. That's why I had to put it
//  into a separate file (this one...)
//
//
//  Author: Harro Verkouter,  23-07-1999
//
//   $Id: History.h,v 1.1.1.1 2000/03/20 15:14:36 verkout Exp $
//
//   $Log: History.h,v $
//   Revision 1.1.1.1  2000/03/20 15:14:36  verkout
//   HV: imported aips++ implement stuff
//
//
//
#ifndef HISTORY_H
#define HISTORY_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef AIPS_STRING_H
#include <aips/Utilities/String.h>
#endif

#ifndef CORRELATORSETUP_H
#include <vlbi/j2ms/CorrrelatorSetup.h>
#endif


//
//  Bookkeeping struct. Need to cache what frequencysetup we wrote
//  to which MS...
//
typedef struct _History
{
    String          msName;
    String          frequencySetup;
    CorrelatorSetup corSetup;
} History;

inline Bool operator==(const History& lhside, const History& rhside)
{
    return ToBool( (lhside.msName==rhside.msName) &&
		   (lhside.frequencySetup==rhside.frequencySetup) &&
		   (lhside.corSetup==rhside.corSetup) );
}

inline Bool operator!=(const History& lhside, const History& rhside)
{
    return ToBool( !(lhside==rhside) );
}

    

#endif
