//
//  IF-based DTD-VisibilityBuffer -> give data IF by IF rather than Matrix by Matrix
//
//
//  Author:   HArro Verkouter,   7-1-1999
//
//  $Id: IFBasedDTDVisBuffer.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef IFBASEDDTDVISBUFFER_H
#define IFBASEDDTDVISBUFFER_H

#ifndef VISIBILITYBUFFER_H
#include <vlbi/j2ms/VisibilityBuffer.h>
#endif

#ifndef AIPS_STRING_H
#include <aips/Utilities/String.h>
#endif

#ifndef VISLABEL_H
#include <vlbi/DtdLUT/VisLabel.h>
#endif

#ifndef AIPS_VECTOR_H
#include <aips/Arrays/Vector.h>
#endif

#ifndef AIPS_MATRIX_H
#include <aips/Arrays/Matrix.h>
#endif

#ifndef VISIBILITY_H
#include <vlbi/j2ms/Visibility.h>
#endif

#include <fstream.h>


class IFBasedDTDVisBuffer :
    public VisibilityBuffer
{
public:
    //
    //  Create it....
    //
    IFBasedDTDVisBuffer( const String& filename, const Experiment* experimentptr );
    
    //
    //  Our own getCurrent() and next() functions
    //
    //virtual Bool          getCurrentVisibility( Visibility& vis ) const;
    virtual Bool          getCurrentVisibility( Visibility& vis );
    virtual Bool          next();
    virtual const String& getRootDir( void ) const;
    

    //
    //  Destruct the object
    //
    virtual ~IFBasedDTDVisBuffer();

private:
    //
    //  Keep track of the integration, job, subarray and ifnr!
    //
    String     itsBaseFilename;
    String     itsRootDir;
    dtd*       itsDTDptr;
    ifstream*  itsDatafileptr;

    uInt       itsCurrentjob;
    uInt       itsCurrentsubarray;
    uInt       itsCurrentIF;
    uLong      itsCurrentintegration;
    
    uLong      itsNrintegrations;

    //
    //  Private methods
    //
    Matrix<Complex>  readData( const ExtVisLabel& labref, Visibility::domain& domainref ) const;

    //
    // Prohibit these
    //
    IFBasedDTDVisBuffer();
    IFBasedDTDVisBuffer( const IFBasedDTDVisBuffer& );
    IFBasedDTDVisBuffer& operator=( const IFBasedDTDVisBuffer& );
};



#endif
