//
//  IniAntennaDB -> specialization of the AntennaDB base-class: reads
//  antennas from an ini-file and keeps a list!
//
//  Author:   Harro Verkouter, 1-12-1998
//
//  $Id: IniAntennaDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef INIANTENNADB_H
#define INIANTENNADB_H

#ifndef ANTENNADB_H
#include <vlbi/j2ms/AntennaDB.h>
#endif

#define ENTRY_ANTNAME      "name"
#define ENTRY_ANTPOSITION  "position"
#define ENTRY_ANTDIAMETER  "diameter"
#define ENTRY_ANTSTATION   "station"

//
//  Forward declarations....
//
class IniFile;



class IniAntennaDB :
    public AntennaDB
{
public:
    //
    //  Create from a file
    //
    IniAntennaDB( const String& inifilename );
    
    //
    //  Lookup something....
    //
    virtual AntennaInfo  operator[]( const String& key ) const;
    virtual Bool         searchAntenna( AntennaInfo& airef, const String& key ) const;

    //
    //  Destruct the object:
    //
    virtual ~IniAntennaDB();

private:
    //
    //  Let's save the name for later use...
    //
    String     itsInifileName;
    IniFile*   itsInifilePtr;

    //
    // Prohibit these:
    //
    IniAntennaDB();
    IniAntennaDB( const IniAntennaDB& );
    IniAntennaDB& operator=( const IniAntennaDB& );
};



#endif
