//
//  IniFrequencyDB - load frequency setups from an inifile
//
//  Author: Harro Verkouter,   3-12-1998
//
//  $Id: IniFrequencyDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef INIFREQUENCYDB_H
#define INIFREQUENCYDB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef FREQUENCYDB_H
#include <vlbi/j2ms/FrequencyDB.h>
#endif

#ifndef AIPS_STRING_H
#include <aips/Utilities/String.h>
#endif

class IniFile;
class FrequencyConfig;


class IniFrequencyDB :
    public FrequencyDB
{
public:
    //
    //  Create the database from the inifile!
    //
    IniFrequencyDB( const String& inifilename );

    //
    //  Provide these functions
    //
    virtual FrequencyConfig  operator[]( const String& key ) const;
    virtual Bool             searchFrequencyConfig( FrequencyConfig& fcref, const String& key ) const;
    
    //
    //  Delete the resources for this database
    //
    virtual ~IniFrequencyDB();

private:
    //
    //  The private parts
    //
    String     itsInifilename;
    IniFile*   itsInifileptr;

    //
    //  Private methods
    //
    Bool       readRecord( FrequencyConfig& fcref, const String& key ) const;

    //
    //  Prohibit these
    //
    IniFrequencyDB();
    IniFrequencyDB( const IniFrequencyDB& );
    IniFrequencyDB& operator=( const IniFrequencyDB& );
};


#endif
