//
//  IniSourceDB -> specialization of the SourceDB base-class: reads
//  antennas from an ini-file and keeps a list!
//
//  Author:   Harro Verkouter, 2-12-1998
//
//  $Id: IniSourceDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef INISOURCEDB_H
#define INISOURCEDB_H

#ifndef SOURCEDB_H
#include <vlbi/j2ms/SourceDB.h>
#endif

#define ENTRY_SOURCENAME       "name"
#define ENTRY_SOURCEDIRECTION  "position"

//
//  Forward declarations....
//
class IniFile;


class IniSourceDB :
    public SourceDB
{
public:
    //
    //  Create from a file
    //
    IniSourceDB( const String& inifilename );
    
    //
    //  Lookup something....
    //
    virtual SourceInfo  operator[]( const String& key ) const;
    virtual Bool        searchSource( SourceInfo& airef, const String& key ) const;

    //
    //  Destruct the object:
    //
    virtual ~IniSourceDB();

private:
    //
    //  Let's save the name for later use...
    //
    String     itsInifileName;
    IniFile*   itsInifilePtr;

    //
    // Prohibit these:
    //
    IniSourceDB();
    IniSourceDB( const IniSourceDB& );
    IniSourceDB& operator=( const IniSourceDB& );
};



#endif
