//
//  SourceDB -> Abstract base-class for classes that whish to act as
//  a SourceDatabase server.
//
//  Must be able to deliver the requested info.
//
//
//  Author:   Harro Verkouter, 2-12-1998
//
//
//   $Id: SourceDB.h,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef SOURCEDB_H
#define SOURCEDB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef SOURCEINFO_H
#include <vlbi/j2ms/SourceInfo.h>
#endif


//
//  Forward declarations
//
class String;


class SourceDB
{
public:
    //
    //  Create a database object...
    //
    SourceDB();

    //
    //  Do a lookup based on code
    //
    virtual SourceInfo operator[]( const String& key ) const = 0;
    virtual Bool       searchSource( SourceInfo& airef, const String& key ) const = 0;
    
    //
    //  Delete the resources this database used....
    //
    virtual ~SourceDB();

private:
    //
    //  Let's prohibit these, it's not wise to copy databases, assign
    //  to them
    //
    SourceDB( const SourceDB& );
    SourceDB& operator=( const SourceDB& );
};



#endif
