//
//  Implementation of the SourceInfo class...
//
//
//  Author:   Harro Verkouter, 2-12-1998
//
//  $Id: SourceInfo.cc,v 1.1.1.1 2000/03/20 15:14:35 verkout Exp $
//
#ifndef SOURCEINFO_H
#include <vlbi/j2ms/SourceInfo.h>
#endif

#include <iomanip.h>


ostream& operator<<( ostream& os, const SourceInfo& siref )
{
    os << siref.itsCode << ": " << siref.itsName << " is at " << siref.itsPosition;

    return os;
}

//
// Default Construct a complete object
//
SourceInfo::SourceInfo( ) :
    itsName( "" ),
    itsCode( "" )
{
}

//
//  The copyconstructor:
//
SourceInfo::SourceInfo( const SourceInfo& other ) :
    itsPosition( other.itsPosition ),
    itsName( other.itsName ),
    itsCode( other.itsCode )
{

}

//
//  Construct a complete object
//
SourceInfo::SourceInfo( const String& name, const String& code, const MDirection& pos ) :
    itsPosition( pos ),
    itsName( name ),
    itsCode( code )
{
}

//
//  Assignment...
//
SourceInfo& SourceInfo::operator=( const SourceInfo& other )
{
    if( this!=&other )
    {
        itsName = other.itsName;
        itsPosition = other.itsPosition;
	itsCode = other.itsCode;
    }
    return *this;
}


const String& SourceInfo::getName() const
{
    return itsName;
}

const String& SourceInfo::getCode() const
{
    return itsCode;
}


const MDirection& SourceInfo::getDirection() const
{
    return itsPosition;
}


SourceInfo::~SourceInfo()
{
}

