//
//  VEXAntennaDB - Specialization of the antennaDB class that reads
//  the antenna info from a VEX-file
//
//  Author: Harro Verkouter,   6-7-1999
//
//  $Id: VEXAntennaDB.h,v 1.1.1.1 2000/03/20 15:14:36 verkout Exp $
//
//  $Log: VEXAntennaDB.h,v $
//  Revision 1.1.1.1  2000/03/20 15:14:36  verkout
//  HV: imported aips++ implement stuff
//
//
#ifndef VEXANTENNADB_H
#define VEXANTENNADB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

//
//  This is our base-class; we need it :-)
//
#ifndef ANTENNADB_H
#include <vlbi/j2ms/AntennaDB.h>
#endif

#ifndef CONTAINER_H
#include <vlbi/tmplsrc/Container.h>
#endif

#ifndef ANTENNAINFO_H
#include <vlbi/j2ms/AntennaInfo.h>
#endif


//
//  Forward declarations....
//



class VEXAntennaDB :
    public AntennaDB
{
public:
    //
    //  Create from a file
    //
    VEXAntennaDB( const String& vexfilename );
    
    //
    //  Lookup something....
    //
    virtual AntennaInfo  operator[]( const String& key ) const;
    virtual Bool         searchAntenna( AntennaInfo& airef, const String& key ) const;

    //
    //  Destruct the object:
    //
    virtual ~VEXAntennaDB();

private:
    //
    //  Let's save the name for later use...
    //
    String                 myVexFileName;
    Container<AntennaInfo> myAntennaList;

    //
    // Prohibit these:
    //
    VEXAntennaDB();
    VEXAntennaDB( const VEXAntennaDB& );
    VEXAntennaDB& operator=( const VEXAntennaDB& );
};


#endif
