//
//  VEXFrequencyDB - Specialization of the FrequencyDB class, reading
//  frequency configurations from a VEX-file....
//
//  Author:  Harro Verkouter,  6-7-1999
//
//  $Id: VEXFrequencyDB.h,v 1.1.1.1 2000/03/20 15:14:36 verkout Exp $
//
//  $Log: VEXFrequencyDB.h,v $
//  Revision 1.1.1.1  2000/03/20 15:14:36  verkout
//  HV: imported aips++ implement stuff
//
//
#ifndef VEXFREQUENCYDB_H
#define VEXFREQUENCYDB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

#ifndef FREQUENCYDB_H
#include <vlbi/j2ms/FrequencyDB.h>
#endif

#ifndef AIPS_STRING_H
#include <aips/Utilities/String.h>
#endif

#ifndef FREQUENCYCONFIG_H
#include <vlbi/j2ms/FrequencyConfig.h>
#endif

#ifndef CONTAINER_H
#include <vlbi/tmplsrc/Container.h>
#endif

//
//  Forward declarations
//



class VEXFrequencyDB :
    public FrequencyDB
{
public:
    //
    //  Create the database from the inifile!
    //
    VEXFrequencyDB( const String& vexfilename );

    //
    //  Provide these functions
    //
    virtual FrequencyConfig  operator[]( const String& key ) const;
    virtual Bool             searchFrequencyConfig( FrequencyConfig& fcref, const String& key ) const;
    
    //
    //  Delete the resources for this database
    //
    virtual ~VEXFrequencyDB();

private:
    //
    //  The private parts
    //
    String                     myVexFileName;
    Container<FrequencyConfig> myConfigurations;
    
    //
    //  Prohibit these
    //
    VEXFrequencyDB();
    VEXFrequencyDB( const VEXFrequencyDB& );
    VEXFrequencyDB& operator=( const VEXFrequencyDB& );
};


#endif
