//
//  VEXSourceDB - Specialization of the SourceDB class that reads
//  the antenna info from a VEX-file
//
//  Author: Harro Verkouter,   6-7-1999
//
//  $Id: VEXSourceDB.h,v 1.1.1.1 2000/03/20 15:14:36 verkout Exp $
//
//  $Log: VEXSourceDB.h,v $
//  Revision 1.1.1.1  2000/03/20 15:14:36  verkout
//  HV: imported aips++ implement stuff
//
//
#ifndef VEXSOURCEDB_H
#define VEXSOURCEDB_H

#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif

//
//  This is our base-class; we need it :-)
//
#ifndef SOURCEDB_H
#include <vlbi/j2ms/SourceDB.h>
#endif

#ifndef CONTAINER_H
#include <vlbi/tmplsrc/Container.h>
#endif

#ifndef SOURCEINFO_H
#include <vlbi/j2ms/SourceInfo.h>
#endif


//
//  Forward declarations....
//



class VEXSourceDB :
    public SourceDB
{
public:
    //
    //  Create from a file
    //
    VEXSourceDB( const String& vexfilename );
    
    //
    //  Lookup something....
    //
    virtual SourceInfo  operator[]( const String& key ) const;
    virtual Bool        searchSource( SourceInfo& airef, const String& key ) const;

    //
    //  Destruct the object:
    //
    virtual ~VEXSourceDB();

private:
    //
    //  Let's save the name for later use...
    //
    String                myVexFileName;
    Container<SourceInfo> mySourceList;

    //
    // Prohibit these:
    //
    VEXSourceDB();
    VEXSourceDB( const VEXSourceDB& );
    VEXSourceDB& operator=( const VEXSourceDB& );
};


#endif
