//
//
//   class:
//   
//             FileFormatConverter
//
//   Purpose:
//
//             To be able to convert one fileformat into another! We
//             implemenmt this by deriving this class from the
//             ConverterBase-class, with two template arguments, both
//             of type String. These two strings are supposedly the
//             input/output filenames. The FileFormatConverter
//             converts the fileformat of the inputfile into another
//             format, and writes the output in the file, spoecified
//             by the outputname.
//
//
//
//      Harro Verkouter, 11-3-1998
//
//   $Id: FileFormatConverter.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef FILEFORMATCONVERTER_H_INC
#define FILEFORMATCONVERTER_H_INC

#include <aips/aips.h>
#include <aips/Utilities/String.h>
//
//  We need this to be able to derive of this class!
//
#include <vlbi/tmplsrc/ConverterBase.h>


//
//  The fileformatconverter class itself
//
class FileFormatConverter : 
    public virtual ConverterBase<String, String>
{

public:
    //
    //  The defualt ctor -> basically we don't have to do anything...
    //
    FileFormatConverter();
    

    //
    //  In order to make the system work, we need to implement this
    //  function...(by the way, we only overload the convert( const..,
    //  const...) function, because we don't want the strings to be
    //  modified.
    //
    virtual Bool convert( const String& outputfilename, const String& inputfilename ) const;

    //
    //  The destructor..destruct this object (nothing yet)
    //
    virtual ~FileFormatConverter();
    
private:
    //
    //  The private data-section
    //

    //
    //  The private method section
    //
    
    //
    //  Prevent copying and assignment
    //
    FileFormatConverter( const FileFormatConverter& );
    FileFormatConverter& operator=( const FileFormatConverter& );
};


#endif
