// class:
//
//     antabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a Classic aips ANTAB binary table extension!
//
//
//  Author:
//
//            Harro Verkouter
//
//
//      $Id: antabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef ANTABGENERATOR_H_INC
#define ANTABGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The antab generator is a specific kind of HDU generator....
//
class antabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default antabGenerator...
    //
    antabGenerator();
    

    //
    // Special interface function: we can ask for the HDU for the
    // specified ARRAY number; every ARRAY has its own ANTAB-hdu.
    //
    // If the HDU was succesfully generated, the return value will be
    // non-null.
    //
    // NOTE: The caller is responsible for (eventually) releasing the
    // allocated resources! (i.e. caller must delete the pointer!)
    //
    Vector<HDUObject*>   generate( MSConversionInfo& inforef );
    

    //
    //  Delete the generator
    //
    virtual ~antabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a antabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //

    //
    //  Prevent copying and assignment
    //
    antabGenerator( const antabGenerator& );
    antabGenerator& operator=( const antabGenerator& );
};



#endif
