// class:
//
//     asciitabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a ASCII TABLE extension!
//
//
//  Author:
//
//            Harro Verkouter
//
//
//      $Id: asciitabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef ASCIITABGENERATOR_H_INC
#define ASCIITABGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The asciitab generator is a specific kind of HDU generator....
//
class asciitabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default asciitabGenerator...
    //
    asciitabGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~asciitabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a asciitabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    asciitabGenerator( const asciitabGenerator& );
    asciitabGenerator& operator=( const asciitabGenerator& );
};



#endif
