//
//  Implementation of class dummyhduGenerator
//
//
//
//   Author:   Harro Verkouter
//             16-3-1998
// 
//   $Id: dummyhduGenerator.cc,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
//
//  My includes
//
#ifndef DUMMYHDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/dummyhduGenerator.h>
#endif

//
//  AIPS++ includes
//
#ifndef FITSPRIMARYARRAY_H_INC
#include <vlbi/ms2uvfitsimpl/FITSUtils/FITSPrimaryArray.h>
#endif


#ifndef MSCONVERSION_H_INC
#include <vlbi/ms2uvfitsimpl/MSConversionInfo.h>
#endif

#include <vlbi/ms2uvfitsimpl/FITSUtils/FITSAxis.h>


#ifndef AIPS_RECORD_H
#include <aips/Containers/Record.h>
#endif


//
//  Default c'tor: nothing to do
//
dummyhduGenerator::dummyhduGenerator()
{
}


//
//  This function performs all the dirty work. It creates a dummy hdu
//  object! It is the callers response to delete the object if he/she
//  no longer desires to use the object!
//
Bool dummyhduGenerator::convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const
{
    FITSAxis          cmplx( "COMPLEX", "The complex axis", 2 );
    FITSAxis          stokes( "STOKES", "The polarization axis", 2, -1.0, -1.0 );
    FITSAxis          ra( "RA", "Position axis (historically)" );
    FITSAxis          declination( "DEC", "Position axis (historically)" );
    Array<Float>      data;
    FITSPrimaryArray* newhdu( new FITSPrimaryArray(TpFloat) );
    
    
    ref2hduptr.resize( 1 );
    ref2hduptr=(HDUObject*)0;
    

    //
    // Ok. "Let's doohooohoo it!" (ref. Lord Flasheart in `BlackAdder
    // goes forth!')
    //


    newhdu->addAxis( cmplx );
    newhdu->addAxis( stokes );
    newhdu->addAxis( ra );
    newhdu->addAxis( declination );


    IPosition    hdushape( newhdu->shape() );
    Record       datarecord;

    data.resize( hdushape );    

    data=Float(0.03);

    
    datarecord.define( "0", data );
    
    newhdu->put( datarecord );

    cout << "Shape: " << hdushape << endl;
    
    //
    //  Create the HDU-object
    //
    ref2hduptr(0)=newhdu;
    
    return True;
}


//
//  The d'tor: nothing to destruct at this moment.....
//
dummyhduGenerator::~dummyhduGenerator()
{
}











