// class:
//
//     dummyhduGenerator
//
//
// Purpose:
//
//
//    The purpose of this class is: when exporting an MS to Classic
//    AIPS via the so called VLBA-Binary table FITS-format (see VLBA
//    Correlator memo #108 by P.J. Diamond, J. Benson etc.) the first
//    entry in the FITS file is a dummy HDU. This 'generator'-object
//    will generate just this HDU!
//
//
//  Author:
//
//            Harro Verkouter
//            16-3-97
//
//      $Id: dummyhduGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef DUMMYHDUGENERATOR_H_INC
#define DUMMYHDUGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif

//
//  The antab generator is a specific kind of HDU generator....
//
class dummyhduGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default dummyHDUgenerator...
    //
    dummyhduGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~dummyhduGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a dummyHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    dummyhduGenerator( const dummyhduGenerator& );
    dummyhduGenerator& operator=( const dummyhduGenerator& );
};



#endif
