// class:
//
//     fqtabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a Classic aips FQTAB binary table extension!
//
//
//  Author:
//
//            Harro Verkouter
//
//
//      $Id: fqtabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef FQTABGENERATOR_H_INC
#define FQTABGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The fqtab generator is a specific kind of HDU generator....
//
class fqtabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default fqtabGenerator...
    //
    fqtabGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~fqtabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a fqtabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    fqtabGenerator( const fqtabGenerator& );
    fqtabGenerator& operator=( const fqtabGenerator& );
};



#endif
