// class:
//
//     gctabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a Classic aips GCTAB binary table extension!
//
//
//  Author:
//
//            Harro Verkouter
//
//
//      $Id: gctabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef GCTABGENERATOR_H_INC
#define GCTABGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The gctab generator is a specific kind of HDU generator....
//
class gctabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default gctabGenerator...
    //
    gctabGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~gctabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a gctabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    gctabGenerator( const gctabGenerator& );
    gctabGenerator& operator=( const gctabGenerator& );
};



#endif
