//
//  Create a FITS-IDI 'ANTENNA' binary table (see AIPS Memo #102 by
//  Chris Flatters, http://www.nrao.edu/~cflatter)
//
//  Author:  Harro Verkouter,  22-09-1999
//
//  $Id: idiantennaGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
//  $Log: idiantennaGenerator.h,v $
//  Revision 1.1.1.1  2000/03/20 15:16:47  verkout
//  HV: Imported aips++ implement-stuff
//
//
#ifndef IDIANTENNAGENERATOR_H
#define INIANTENNAGENERATOR_H

//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The idiantenna generator is a specific kind of HDU generator....
//
class idiantennaGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default idiantennaGenerator...
    //
    idiantennaGenerator();
    
    //
    //
    // NOTE: The caller is responsible for (eventually) releasing the
    // allocated resources! (i.e. caller must delete the pointer(s)!)
    //
    Vector<HDUObject*>   generate( MSConversionInfo& inforef );
    
    //
    //  Delete the generator
    //
    virtual ~idiantennaGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a idiantennaHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //

    //
    //  Prevent copying and assignment
    //
    idiantennaGenerator( const idiantennaGenerator& );
    idiantennaGenerator& operator=( const idiantennaGenerator& );
};


#endif
