//
//  Generate a FREQUENCY table, as defined in the FITS IDI format
//  (ref. AIPS Memo #102, The FITS Interferometery Data Interchange
//  format by Chris Flatters (http://www.nrao.edu/~cflatter)
//
//
//  Author:  Harro Verkouter,  22-09-1999
//
//  $Id: idifrequencyGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
//  $Log: idifrequencyGenerator.h,v $
//  Revision 1.1.1.1  2000/03/20 15:16:47  verkout
//  HV: Imported aips++ implement-stuff
//
//
#ifndef IDIFREQUENCYGENERATOR_H
#define IDIFREQUENCYGENERATOR_H

//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The idifrequency generator is a specific kind of HDU generator....
//
class idifrequencyGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default idifrequencyGenerator...
    //
    idifrequencyGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~idifrequencyGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a idifrequencyHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    idifrequencyGenerator( const idifrequencyGenerator& );
    idifrequencyGenerator& operator=( const idifrequencyGenerator& );
};


#endif
