//
//
//  Generate a FITS-IDI header object to be placed as empty primary
//  array HDU in a FITS IDI file (such that classic aips recognizes it
//  as such)
//
//  Author: Harro Verkouter, 16-09-1999
//
//
//  $Id: idihdrGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
//  $Log: idihdrGenerator.h,v $
//  Revision 1.1.1.1  2000/03/20 15:16:47  verkout
//  HV: Imported aips++ implement-stuff
//
//
#ifndef IDIHDRGENERATOR_H
#define IDIHDRGENERATOR_H

//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif

//
//  The IDI-Header  generator is a specific kind of HDU generator....
//
class idihdrGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default dummyHDUgenerator...
    //
    idihdrGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~idihdrGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a dummyHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    idihdrGenerator( const idihdrGenerator& );
    idihdrGenerator& operator=( const idihdrGenerator& );
};


#endif
