//
//  IDI-Source Generator -> generates a binary table extension,
//  conforming to the definition of the SOURCE table, as defined in
//  AIPS Memo #102, The FITS Interferometry Data Interchange format by
//  Chris Flatters (http://www.nrao.edu/~cflatter)
//
//  Author:  Harro Verkouter,  23-09-1999
//
//  $Id: idisourceGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
//  $Log: idisourceGenerator.h,v $
//  Revision 1.1.1.1  2000/03/20 15:16:47  verkout
//  HV: Imported aips++ implement-stuff
//
//
#ifndef IDISOURCEGENERATOR_H
#define IDISOURCEGENERATOR_H


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The idisource generator is a specific kind of HDU generator....
//
class idisourceGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default idisourceGenerator...
    //
    idisourceGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~idisourceGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a idisourceHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    idisourceGenerator( const idisourceGenerator& );
    idisourceGenerator& operator=( const idisourceGenerator& );
};



#endif
