// class:
//
//     maingroupGenerator
//
//
// Purpose:
//
//
//    The purpose of this class is: when exporting an MS to Classic
//    AIPS via the so called VLBA-Binary table FITS-format (see VLBA
//    Correlator memo #108 by P.J. Diamond, J. Benson etc.) the first
//    entry in the FITS file is a dummy HDU. This 'generator'-object
//    will generate just this HDU!
//
//
//  Author:
//
//            Harro Verkouter
//            05-06--97
//
//      $Id: maingroupGenerator.h,v 1.2 2000/09/22 13:17:13 verkout Exp $
#ifndef MAINGROUPGENERATOR_H_INC
#define MAINGROUPGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif

//
//  The antab generator is a specific kind of HDU generator....
//
class maingroupGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  Static method to convert a time into a day and dayfraction!
    //
    static void  timeToDay( Double& day, Double& dayfraction, Double time );


    //
    //  The default maingroupgenerator...
    //
    maingroupGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~maingroupGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a maingroup!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //

    //
    //  Private methods
    //

    

    //
    //  Prevent copying and assignment
    //
    maingroupGenerator( const maingroupGenerator& );
    maingroupGenerator& operator=( const maingroupGenerator& );
};



#endif
