// class:
//
//     sutabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a Classic aips SUTAB binary table extension!
//
//
//  Author:
//
//            Harro Verkouter, 10-8-1998
//
//
//      $Id: sutabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef SUTABGENERATOR_H_INC
#define SUTABGENERATOR_H_INC

//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif

//
//  Aips++ includes
//
#ifndef AIPS_AIPS_H
#include <aips/aips.h>
#endif


//
//  Forward declarations
//
class ROTableColumn;


//
//  The sutab generator is a specific kind of HDU generator....
//
class sutabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default sutabGenerator...
    //
    sutabGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~sutabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a sutabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    sutabGenerator( const sutabGenerator& );
    sutabGenerator& operator=( const sutabGenerator& );
};


//
//  Define a function to retrieve the Epoch from a column
//
//  If the keyword cannot be found, 0.0 is returned. Otherwise it
//  attempts to return 1950.0 or 2000.0
//
Double  getEpoch( const ROTableColumn& column );


#endif
