// class:
//
//     tableGenerator
//
//
// purpose:
//
//
//     To generate MSTables from a HeaderDataUnit (whichh can be
//     accessed via the FITSConversionInfo that's passed as argument.
//
//
// Author:      Harro Verkouter  12-3-1998
//
//   $Id: tableGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
//
#ifndef TABLEGENERATOR_H_INC
#define TABLEGENERATOR_H_INC

#ifndef CONVERTERBASE_H_INC
#include <vlbi/tmplsrc/ConverterBase.h>
#endif

#ifndef AIPS_TABLE_H
#include <aips/Tables/Table.h>
#endif

//
//  I think we can get away with these as forward declarations: we're
//  not going to use them other than by reference!
//
class FITSConversionInfo;


class tableGenerator :
    public virtual ConverterBase<Table*, FITSConversionInfo>
{
public:
    //
    //  The default ctor: nothing to do!
    //
    tableGenerator();
    
    //
    // Ok. The only public method: generate the Table (below the
    // surface, we use the 'convert', which is virtual)
    //
    //  Upon succesful generation, returns non-null pointer. Otherwise
    //  null is returned! 
    //
    //  Note: 
    //        +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //
    //        The caller is responsible for deleting the Table object!!!!!!
    //
    //        +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    Table*  generate( FITSConversionInfo& inforef ) const;
    
    //
    //  The dtor: (nothing to do)
    //
    virtual ~tableGenerator();

protected:
    //
    //  This function call is protected: not to be used by the caller
    //  directly: we supply the generate method for that! Derived
    //  classes should implement this method!
    //
    virtual Bool convert( Table*& ref2tableptr, FITSConversionInfo& inforef ) const;

    
private:
    //
    //  The objects private parts
    //

    //
    //  Prevent copying/assignment
    //
    tableGenerator( const tableGenerator& );
    tableGenerator& operator=( const tableGenerator& );
};


#endif
