// class:
//
//     tytabGenerator
//
//
// Purpose:
//
//
//     From a MSConversionInfo object, extract the info needed to
//     build a Classic aips TYTAB binary table extension!
//
//
//  Author:
//
//            Harro Verkouter
//
//
//      $Id: tytabGenerator.h,v 1.1.1.1 2000/03/20 15:16:47 verkout Exp $
#ifndef TYTABGENERATOR_H_INC
#define TYTABGENERATOR_H_INC


//
//  Aips++ includes
//


//
// My includes
//
#ifndef HDUGENERATOR_H_INC
#include <vlbi/ms2uvfitsimpl/Generators/hduGenerator.h>
#endif


//
//  The tytab generator is a specific kind of HDU generator....
//
class tytabGenerator :
    public virtual hduGenerator
{
    //
    //  The public section:
    //
public:

    //
    //  The default tytabGenerator...
    //
    tytabGenerator();
    

    //
    //  Delete the generator
    //
    virtual ~tytabGenerator();
    
protected:
    //
    //  This virtual function is called by the base class: it is a
    //  request to actually generate a tytabHDU!
    //
    virtual Bool  convert( Vector<HDUObject*>& ref2hduptr, MSConversionInfo& inforef ) const;
    

private:
    //
    //  The object's private parts go here:
    //
    //
    //  Prevent copying and assignment
    //
    tytabGenerator( const tytabGenerator& );
    tytabGenerator& operator=( const tytabGenerator& );
};



#endif
